#generation de N control chart time series, sur D points de discretisation ;
#amplitude de reference: D==60 (parametres 59.5, 59.0/(D-1) a modifier eventuellement)
CCT_gen = function(N,D) {
	if (N %% 6 > 0) N = N + (6 - N %% 6)
	curves = matrix(nrow=N,ncol=D)

	m=30; s=2
	times = seq(from=0.5,to=59.5,by = 59.0/(D-1))
	seqHalf=seq(from=0.5,to=D-0.5)

	#1/6 of each type :
	for (i in 1:N) {
		r = runif(D,min=-3,max=3)
		valTest = (6*(i-1)) %/% N

		if (valTest == 0) {
			curves[i,] = m + s*r
		}
		else if (valTest == 1) {
			a = runif(D,min=10,max=15)
			T = runif(D,min=10,max=15)
			curves[i,] = m + s*r + a*sin(2*pi*seqHalf / T)
		}
		else if (valTest == 2) {
			g = runif(D,min=0.2,max=0.5)
			curves[i,] = m + s*r + g*times
		}
		else if (valTest == 3) {
			g = runif(D,min=0.2,max=0.5)
			curves[i,] = m + s*r - g*times
		}
		else if (valTest == 4) {
			t0 = runif(1,min=D/3,max=2*D/3)
			x = runif(D-t0+1,min=7.5,max=20)
			curves[i,] = m + s*r
			curves[i,t0:D] = curves[i,t0:D] + x
		}
		else {
			t0 = runif(1,min=D/3,max=(2*D)/3)
			x = runif(D-t0+1,min=7.5,max=20)
			curves[i,] = m + s*r
			curves[i,t0:D] = curves[i,t0:D] - x
		}
	}

	return (curves)
}
