require(wmtsa)
source('../R_Routines/Article/basisSearch.R')
source('../R_Routines/Article/scriptTests.R')
source('../R_Routines/Article/CCT_generator.R')
source('../R_Routines/Article/drawResults.R')


# CCT #

#params :
nclusts = 6
dataSize = seq(from=100,to=3100,by=200) #tester avec tranches de 100, de 100 a 2000 eventuellement..
ldata = length(dataSize)
for (i in 1:ldata) {
	if (dataSize[i] %% 6 > 0)
		dataSize[i] = dataSize[i] + (6 - dataSize[i] %% 6)
}
dimensions = seq(from=2,to=50,by=4)
D = 128 ; lvl = floor( log(D) / log(2) )
nrowsRef = 18000
filt = "haar"
ldims = length(dimensions)

######## CCT runs :

N = 1 # number of runs (30 for the article)
res_cct = as.list(rep(0,3*N))
disto_ref = 0
for (i in 1:N) {
	print(paste("********* RUN ",i,"*********"))
	cb = CCT_ClustBasis(dataSize,dimensions,nclusts,D,nrowsRef,filt)
	disto_ref = disto_ref + (cb$dref)/N
	res_cct[[3*i-2]] = cb$distors
	res_cct[[3*i-1]] = cb$clusters
	res_cct[[3*i]] = cb$centers
}

#do statistics (only on distortions..) :
distorsCCT = 0
for (i in 1:N) distorsCCT = distorsCCT + res_cct[[3*i-2]] / N
#distorsCCT = distorsCCT - disto_ref

#resume all clusters :
clusters_cct = as.list(rep(0,N))
for (i in 1:N) clusters_cct[[i]] = res_cct[[3*i-1]]

#resume all centers :
centers_cct = as.list(rep(0,N))
for (i in 1:N) centers_cct[[i]] = res_cct[[3*i]]


# CAT #

######## cathare "0" runs :

nclusts = 2 ; D = 256
lvl = floor( log(D) / log(2) )
cbc = cat_ClustBasis("cat",dimensions,nclusts,D,filt)
#distorCat = cbc$distors - cbc$dref

######## bemuse1 runs :

cbb1 = cat_ClustBasis("bem1",dimensions,nclusts,D,filt)
#distorBem1 = cbb1$distors - cbb1$dref

######## bemuse2 runs :

nclusts = 3 ; D = 1024
lvl = floor( log(D) / log(2) )
cbb2 = cat_ClustBasis("bem2",dimensions,nclusts,D,filt)
#distorBem2 = cbb2$distors - cbb2$dref
