require(wmtsa)

#script pour lancer les tests :

basisInitialize = function(data,lvl,nclusts,dMax,D,filt) {
	print("basisBwav")
	bb = bestBasis(data, lvl, costType='entropy', nclusts, dMax)
	basisBwav = bb$base
#	basisBwav = bestWavelets(data, lvl, "haar", costType='entropy', dMax) #correction pr results plus beaux 
																		#[mais pas exactement best entropy]
																		# --> marche pas !!!
#	print(paste("    best filter : ",bb$bfilt))
	print("basisNwav")
	basisNwav = threshWav(data, lvl, filt, dMax, withVar=TRUE)
	print("basisFpca")
	s = svd(data)
	basisFpca = t((s$v)[,1:min(dMax,ncol(s$v))])
	print("basisFour")
	basisFour = genFourier(data,dMax,withVar=TRUE)#withVar=FALSE)

	return (list('bbwav'=basisBwav,'bnwav'=basisNwav,'bfpca'=basisFpca,'bfour'=basisFour))
}

#control chart time series : grid
CCT_ClustBasis = function(dataSize=c(100,200,300),dimensions=c(2,6,10),nclusts=6,D=128,nrowsRef=18000,filt="s8") {
	print("preliminary computations...")
	lvl = floor(log(D) / log(2))
	cct_ref = CCT_gen(nrowsRef,D)
	#get "infinite" distorsion :
	km = kmeans(cct_ref,nclusts,iter.max=500,nstart=100)
	disto_ref = distortion(cct_ref,km$centers) #sum(km$withinss)
	print("    done.")

	#for --> n for --> d :
	ldata = length(dataSize)
	ldims = length(dimensions)
	#memoriser distorsions :
	distors = rep(0,4*ldata*ldims) #ordre four, fpca, nwav puis bwav pour chaque couple (n,d)
	#memoriser clusters
	clusters = as.list(rep(0,ldata))
	for (i in 1:ldata) clusters[[i]] = matrix(nrow=4*ldims,ncol=dataSize[i])
	#memoriser centres
	centers = matrix(nrow=4*nclusts*ldata*ldims,ncol=D)

	for (i in 1:ldata) {
		print("preliminary computations...")
		cct = CCT_gen(dataSize[i],D)
		s = svd(cct)
		#get basis :
		bb_cct = basisInitialize(cct,lvl,nclusts,max(dimensions),D,filt)
		print("    done.")
		
		for (j in 1:ldims) {
			print("basis computations...")
			basisFour = basisMostVar(bb_cct$bfour,cct,dimensions[j],verbose=TRUE)#bb_cct$bfour[1:dimensions[j],]
			basisFpca = t((s$v)[,1:min(dimensions[j],ncol(s$v))])
			basisNwav = basisMostVar(bb_cct$bnwav,cct,dimensions[j],verbose=TRUE)
			basisBwav = basisMostVar(bb_cct$bbwav,cct,dimensions[j],verbose=TRUE)
			print("    done.")

			print(paste("four, n=",i,"d=",j))
			#four :
			ab = allParamsBasis(cct, basisFour, nclusts, dimensions[j], cct_ref)
			distors[(i-1)*(4*ldims)+4*(j-1)+1] = ab$disto
			clusters[[i]][4*(j-1)+1,] = ab$clusts
			centers[((i-1)*(4*nclusts*ldims)+(j-1)*(4*nclusts)+1):((i-1)*(4*nclusts*ldims)+(j-1)*(4*nclusts)+nclusts),] = ab$ctrs

			print(paste("fpca, n=",i,"d=",j))
			#fpca :
			ab = allParamsBasis(cct, basisFpca, nclusts, dimensions[j], cct_ref)
			distors[(i-1)*(4*ldims)+4*(j-1)+2] = ab$disto
			clusters[[i]][4*(j-1)+2,] = ab$clusts
			centers[((i-1)*(4*nclusts*ldims)+(j-1)*(4*nclusts)+nclusts+1):((i-1)*(4*nclusts*ldims)+(j-1)*(4*nclusts)+2*nclusts),] = ab$ctrs
	
			print(paste("nwav, n=",i,"d=",j))
			#nwav :
			ab = allParamsBasis(cct, basisNwav, nclusts, dimensions[j], cct_ref)
			distors[(i-1)*(4*ldims)+4*(j-1)+3] = ab$disto
			clusters[[i]][4*(j-1)+3,] = ab$clusts
			centers[((i-1)*(4*nclusts*ldims)+(j-1)*(4*nclusts)+2*nclusts+1):((i-1)*(4*nclusts*ldims)+(j-1)*(4*nclusts)+3*nclusts),] = ab$ctrs
	
			print(paste("bwav, n=",i,"d=",j))
			#bwav :
			ab = allParamsBasis(cct, basisBwav, nclusts, dimensions[j], cct_ref)
			distors[(i-1)*(4*ldims)+4*(j-1)+4] = ab$disto
			clusters[[i]][4*(j-1)+4,] = ab$clusts
			centers[((i-1)*(4*nclusts*ldims)+(j-1)*(4*nclusts)+3*nclusts+1):((i-1)*(4*nclusts*ldims)+(j-1)*(4*nclusts)+4*nclusts),] = ab$ctrs
		}
	}

	return (list('dref'=disto_ref,'distors'=distors,'clusters'=clusters,'centers'=centers))
}

#"cathare 0" or bemuse 1, 2 :
cat_ClustBasis = function(type="cat",dimensions=c(2,6,10),nclusts=3,D=1024,filt="s8") {
	print("preliminary computations...")
	lvl = floor(log(D) / log(2))
	funcs = matrix()
	if (type=="cat") funcs = expandSplines(as.matrix(read.table('cathare.out')),D) #data_ref = data here
	else if (type=="bem1") funcs = expandSplines(as.matrix(read.table('bemuse1.out')),D)
	else if (type=="bem2") funcs = expandSplines(as.matrix(read.table('bemuse2.out')),D)
	n = nrow(funcs)
	#get "infinite" distorsion :
	km = kmeans(funcs,nclusts,iter.max=500,nstart=100)
	disto_ref = distortion(funcs,km$centers) #sum(km$withinss)
	print("    done.")

	#for --> d :
	ldims = length(dimensions)
	#memoriser distorsions :
	distors = rep(0,4*ldims) #ordre four, fpca, nwav puis bwav pour chaque d
	#memoriser clusters
	clusters = matrix(nrow=4*ldims,ncol=n)
	#memoriser centres
	centers = matrix(nrow=4*nclusts*ldims,ncol=D)

	#in this case, only n=100 (or 200)
	print("preliminary computations...")
	s = svd(funcs)
	#get basis :
	bb_funcs = basisInitialize(funcs,lvl,nclusts,max(dimensions),D,filt)
	print("    done.")
		
	for (i in 1:ldims) {
		print("preliminary computations...")
		basisFour = basisMostVar(bb_funcs$bfour,funcs,dimensions[i],verbose=TRUE)#bb_funcs$bfour[1:dimensions[i],]
		basisFpca = t((s$v)[,1:min(dimensions[i],ncol(s$v))])
		basisNwav = basisMostVar(bb_funcs$bnwav,funcs,dimensions[i],verbose=TRUE)
		basisBwav = basisMostVar(bb_funcs$bbwav,funcs,dimensions[i],verbose=TRUE)
		print("    done.")

		print(paste("four, n=",n,"d=",i))
		#four :
		ab = allParamsBasis(funcs, basisFour, nclusts, dimensions[i], funcs)
		distors[4*(i-1)+1] = ab$disto
		clusters[4*(i-1)+1,] = ab$clusts
		centers[((i-1)*(4*nclusts)+1):((i-1)*(4*nclusts)+nclusts),] = ab$ctrs

		print(paste("fpca, n=",n,"d=",i))
		#fpca :
		ab = allParamsBasis(funcs, basisFpca, nclusts, dimensions[i], funcs)
		distors[4*(i-1)+2] = ab$disto
		clusters[4*(i-1)+2,] = ab$clusts
		centers[((i-1)*(4*nclusts)+nclusts+1):((i-1)*(4*nclusts)+2*nclusts),] = ab$ctrs

		print(paste("nwav, n=",n,"d=",i))
		#nwav :
		ab = allParamsBasis(funcs, basisNwav, nclusts, dimensions[i], funcs)
		distors[4*(i-1)+3] = ab$disto
		clusters[4*(i-1)+3,] = ab$clusts
		centers[((i-1)*(4*nclusts)+2*nclusts+1):((i-1)*(4*nclusts)+3*nclusts),] = ab$ctrs

		print(paste("bwav, n=",n,"d=",i))
		#bwav :
		ab = allParamsBasis(funcs, basisBwav, nclusts, dimensions[i], funcs)
		distors[4*(i-1)+4] = ab$disto
		clusters[4*(i-1)+4,] = ab$clusts
		centers[((i-1)*(4*nclusts)+3*nclusts+1):((i-1)*(4*nclusts)+4*nclusts),] = ab$ctrs
	}

	return (list('dref'=disto_ref,'distors'=distors,'clusters'=clusters,'centers'=centers))
}
